# ANNA

Multi-purpose C++ development suite, focused on Telco resources (communications, protocols and tools).
ANNA is acronym for "Anna is not nothingness anymore", that is to say: "Anna is something to take into
account" (like a SONaTINA).

ANNA is a complete suite of tools and resources to build proffesional applications with minimum cost.

## Revision control

Based on GIT, hosted on http://redmine.teslayout.com

You could use my pre-commit specific template if you want to do some basic checkings (i.e.
 astyle code processing): Execute './scripts/git/use-pre-commit.sh'


## Build project

This is a CMake based building suite.
Install cmake:

     > sudo apt-get install cmake

And then generate the makefiles from project root directory:

     > cmake .

You could specify type of build, 'Debug' or 'Release', for example:

     > cmake -DCMAKE_BUILD_TYPE=Debug .
     > cmake -DCMAKE_BUILD_TYPE=Release .

## Clean project

     > make clean

## Change the compilers

     > cmake -DCMAKE_CXX_COMPILER=/usr/bin/g++     -DCMAKE_C_COMPILER=/usr/bin/gcc
     or
     > cmake -DCMAKE_CXX_COMPILER=/usr/bin/clang++ -DCMAKE_C_COMPILER=/usr/bin/clang

## Some basic ubuntu requirements

### OpenSSL:
     > sudo apt-get install libssl-dev
 
### Gnome XML:
     > sudo apt-get install libxml2-dev

### OpenLDAP:
     > sudo apt-get install libldap2-dev

### Pcap:
     > sudo apt-get install libpcap-dev

### MySql:
     > sudo apt-get install libmysqlclient-dev

### Oracle:
     https://help.ubuntu.com/community/Oracle%20Instant%20Client
     Set 'ORACLE_HOME' environment variable in your profile, i.e.:
        export ORACLE_HOME=/usr/lib/oracle/12.1/client64/

     Be sure to create in that directory, a link to oracle includes,
     for example:

	> /usr/lib/oracle/12.1/client64$ ls -lrt
	total 8
	drwxr-xr-x 2 root root 4096 Feb 28 15:59 bin
	drwxr-xr-x 2 root root 4096 Feb 28 15:59 lib
	lrwxrwxrwx 1 root root   33 Feb 28 16:07 include -> /usr/include/oracle/12.1/client64

     The alternative is to edit SConstruct file directly to set
     oracle includes directory.

### Oracle-OpenLDAP conflict:
     as usual, Oracle is doing things very bad. Move the ldap.h from oracle includes, i.e.:

        > cd /usr/include/oracle/12.1/client64
        > sudo mv ldap.h ldap.h.orig

### Google Test Framework:

     > sudo apt-get install libgtest-dev

     Note that this package only install source files. You have to compile the
     code yourself to create the necessary library files. These source files
     should be located at /usr/src/gtest. Browse to this folder and use cmake
     to compile the library:

     > cd /usr/src/gtest
     > sudo cmake CMakeLists.txt
     > sudo make
 
     Copy or symlink libgtest.a and libgtest_main.a to your /usr/lib folder:
     > sudo cp *.a /usr/lib

## Documentation

Execute 'make doc'

     > cd docs/doxygen
     > tree -L 1

     .
     ├── Doxyfile
     ├── html
     ├── latex
     └── man


## Unit tests

Execute 'make test'

## Install

To install headers, libraries, and examples, execute:

     > make install

Optionally you could specify another prefix for installation:

     > cmake -DCMAKE_INSTALL_PREFIX=$HOME/anna_deploy .

## Uninstall

     > cat install_manifest.txt | sudo xargs rm


