#!/bin/sh

#############
# VARIABLES #
#############
DEPLOY_SCR=`dirname $0`/deploy.sh

#############
# FUNCTIONS #
#############
_exit() {
  echo
  echo $1
  echo
  exit 1
}

#############
# EXECUTION #
#############
type=$1
target=$2

echo
echo "               ----------------------------"
echo "               SETUPS DEPLOYMENT AUTOMATION"
echo "               ----------------------------"
echo
echo "-----------------------------------------------------------"
echo "Usage: $0 [type] [target_directory]"
echo
echo "          type:"
echo "                1. Client and server"
echo "                2. Ft-client and server"
echo "                3. St-client and servers"
echo "                4. Single deployment"
echo
echo "          target_directory:"
echo
echo "                Non existing directory to install the stuff"
echo
echo "-----------------------------------------------------------"
echo
[ "$type" = "" ] && { echo "Which one you want to deploy [1]:" ; read type ; }
[ "$type" = "" ] && type=1

case $type in
  1)
    echo "Selected Client-Server"
    DEPLOY_DIR__dflt=$HOME/ADML-clientAndServer
  ;;

  2)
    echo "Selected Client-Server FT"
    DEPLOY_DIR__dflt=$HOME/ADML-ftclientAndServer
  ;;

  3)
    echo "Selected Client-Servers ST"
    DEPLOY_DIR__dflt=$HOME/ADML-stclientAndServers
  ;;

  4)
    echo "Selected single deployment"
    DEPLOY_DIR__dflt=$HOME/ADML-single
  ;;

  *)
    echo "Unknown option!"
    exit 1
  ;;
esac
echo


[ "$target" = "" ] && { echo "Directory for deploy [$DEPLOY_DIR__dflt]:" ; read target ; }
[ "$target" = "" ] && target=$DEPLOY_DIR__dflt
[ -d $target ] && _exit "The directory '$target' already exists !"
echo "Target directory: $target"

case $type in
  1)
    $DEPLOY_SCR b $target/ADML-client
    $DEPLOY_SCR b $target/ADML-server
    echo "Configuring ..."
    cd $target/ADML-client
    echo c | ./configure.sh >/dev/null
    cd - >/dev/null
    cd $target/ADML-server
    echo s | ./configure.sh >/dev/null
    cd - >/dev/null
  ;;

  2)
    $DEPLOY_SCR f $target/ADML-ft-client
    $DEPLOY_SCR b $target/ADML-server
    echo "Configuring ..."
    cd $target/ADML-server
    echo s | ./configure.sh >/dev/null
    cd - >/dev/null
  ;;

  3)
    $DEPLOY_SCR s $target/ADML-st-client
    $DEPLOY_SCR b $target/ADML-serverGx
    $DEPLOY_SCR b $target/ADML-serverRx
    echo "Configuring ..."
    cd $target/ADML-serverGx
    echo s | ./configure.sh >/dev/null
    sed -i 's/3868/3869/' services.xml
    # Gx dictionary:
    ln -sf stacks/other_examples/16777238.xml dictionary.xml
    cd - >/dev/null
    cd $target/ADML-serverRx
    echo s | ./configure.sh >/dev/null
    # Rx dictionary:
    ln -sf stacks/other_examples/16777236.xml dictionary.xml
    cd - >/dev/null
  ;;

  4)
    $DEPLOY_SCR b $target
    echo "Configuring ..."
    cd $target
    echo d | ./configure.sh >/dev/null
    cd - >/dev/null
  ;;

esac

echo
echo "Done!"
echo

