#!/bin/bash
cd `dirname $0`
if [ ! -d "ADMLS" ]
then
  echo
  echo "Run './configure.sh' first !"
  echo
  exit 1
fi

for run in `ls ADMLS/*/run.sh`
do
  cd `dirname $run`
  instance_name=$(basename $PWD)
  pkill $instance_name
  [ $? -eq 0 ] && echo -n "Re-" 
  echo "Starting $instance_name ..."
  ./run.sh > /dev/null &
  cd - >/dev/null
done
echo
wait $(jobs -p)

sleep 3
./checkStatus.sh

cat << EOF
     $(pgrep ADML- | wc -l) instances alive !
     $(netstat -a | grep :diameter | grep ESTABLISHED | wc -l) connections established !

     To stop the processes, you could execute: pgrep ADML-[0-9] | xargs kill
     Anyway, executing './run.sh' again you will restart the ADML instances.

     Now it's time to './program.sh' the started instances with the desired
     scenary. There are two programming variants:

          ./program.sh <test stuff directory>
          ./program.sh dynamic


     Done!
EOF

echo

