#!/bin/bash
dynamicProcedureLibName=libanna_dynamicLauncherProcedure.so
echo
echo "------------------------------------------------"
echo "Dynamic library selection for launcher procedure"
echo "------------------------------------------------"
cd $(dirname $0)
option=$1
rm -f $dynamicProcedureLibName
if [ -z "$option" ]
then
  echo " (you could provide directly the path to the .so file)"
  echo
  echo "Available options:"
  tmpfile=$(mktemp)
  find . -name "$dynamicProcedureLibName" > $tmpfile
  echo
  for line in $(cat $tmpfile); do echo "   $line" ; done
  dflt=$(grep "^./default/" $tmpfile)
  echo
  echo -n "Paste your selection [$dflt]: "
  read option
  [ -z "$option" ] && option=$dflt
  rm $tmpfile 
fi

[ ! -f $option ] && { echo -e "\nInvalid file !\n" ; exit 1 ; }
option_bn=$(basename $option)
[ "$option_bn" != "$dynamicProcedureLibName" ] && { echo -e "\nInvalid file (must be a dynamic procedure library) !\n" ; exit 1 ; }
ln -sf $option $dynamicProcedureLibName
echo
echo "Library enabled"
echo

