// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_codec_basetypes_UTF8String_hpp
#define anna_diameter_codec_basetypes_UTF8String_hpp


// Local
#include <anna/diameter/codec/basetypes/OctetString.hpp>


namespace anna {

namespace diameter {

namespace codec {

class Avp;

namespace basetypes {

/**
* Diameter UTF8String container
*/
class UTF8String : public OctetString {
// Note that the AVP Length field of an UTF8String is measured in octets, not characters.
// De momento no vamos a interpretar/decodificar este tipo de formato, puesto que an no se ha necesitado a nivel de aplicacin

  // Only for derived diameter type:
  void updateBasic() throw(anna::RuntimeException); // assertPrintable

public:

  // gets

  std::string getFormatName() const throw() { return "UTF8String"; }


  // helpers


  // sets

  void decode(const char* buffer, const int size) throw(anna::RuntimeException);
};

}
}
}
}

#endif

