// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Project
#include <anna/diameter/codec/EngineManager.hpp>
#include <anna/diameter/codec/Engine.hpp>
#include <anna/diameter/stack/Engine.hpp>
#include <anna/diameter/stack/Dictionary.hpp>
#include <anna/core/tracing/Logger.hpp>
#include <anna/xml/Node.hpp>


using namespace anna::diameter::codec;

Engine *EngineManager::getCodecEngine(const ApplicationId &appid) const throw() {
  appid_codec_engines_it it = a_appid_codec_engines.find(appid);
  if (it != a_appid_codec_engines.end())
    return it->second;

  return NULL;
}

void EngineManager::registerCodecEngine(const ApplicationId &appid, Engine* engine) throw() {
  if (!engine) return; // nothing done
  a_appid_codec_engines[appid] = engine;
}

anna::xml::Node* EngineManager::asXML(anna::xml::Node* parent) const
throw() {
  anna::xml::Node* result = parent->createChild("EngineManager");
  appid_codec_engines_it it_min(a_appid_codec_engines.begin());
  appid_codec_engines_it it_max(a_appid_codec_engines.end());
  for (appid_codec_engines_it it = it_min; it != it_max; it++)
    it->second->asXML(result);

  return result;
}
