// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <string.h>
#include <stdlib.h>

#include <anna/config/defines.hpp>
#include <anna/core/functions.hpp>

#include <anna/http/internal/Token.hpp>

using namespace std;
using namespace anna;

const string& http::Token::getStringValue() const
throw() {
  if(contains(0) == false)
    const_cast <Token*>(this)->a_aux.assign(DataBlock::getData(), DataBlock::getSize());
  else
    const_cast <Token*>(this)->a_aux = DataBlock::getData();

  return a_aux;
}

int http::Token::getIntegerValue() const
throw() {
  if(contains(0) == false) {
    const_cast <Token*>(this)->a_aux.assign(DataBlock::getData(), DataBlock::getSize());
    return atoi(a_aux.c_str());
  }

  return atoi(DataBlock::getData());
}

bool http::Token::contains(const char byte) const
throw() {
  const char* p;
  const char* maxp;

  for(p = DataBlock::getData(), maxp = p + DataBlock::getSize(); p < maxp; p ++) {
    if(*p == byte)
      return true;
  }

  return false;
}

int http::Token::calculeOffset(const DataBlock& base) const
throw(RuntimeException) {
  const int result = getData() - base.getData();

  if(result < 0) {
    string msg("anna::http::Token::calculeOffset | Invalid address for the token: ");
    msg += functions::asString(*this);
    throw RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  return result;
}

bool http::Token::match(const char* str) const
throw() {
  const char* pp = DataBlock::getData();
  int size = DataBlock::getSize();

  while(size > 0) {
    if(*pp != ' ')
      break;

    size --;
    pp ++;
  }

  return (anna_strlen(str) != size) ? false : (strncasecmp(pp, str, size) == 0);
}
