// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/functions.hpp>

#include <anna/timex/TimeEvent.hpp>
#include <anna/timex/Engine.hpp>
#include <anna/timex/TimeEventObserver.hpp>

using namespace anna;

anna::timex::TimeEvent::~TimeEvent() {
  if(a_controller != NULL) {
    try {
      a_controller->cancel(this);
    } catch(Exception& ex) {
      ex.trace();
    }
  }
}

std::string anna::timex::TimeEvent::asString() const
throw() {
  std::string result("timex::TimeEvent { Id: ");
  result += functions::asHexString(a_id);
  result += " | Reference: ";
  result += functions::asHexString(anna_ptrnumber_cast(this));
  result += " | Timeout: ";
  result += functions::asString(a_timeout);
  result += " ms";

  if(a_observer != NULL) {
    result += " | ";
    result += a_observer->asString();
  }

  return result += " }";
}


